<?php

namespace App\Models;

use App\Classes\ValueObjects\Constants\SegmentConstants;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * Class SegmentConstant
 * @package App\Models
 *
 * @property \App\Models\Segment segment_id
 * @property string detail
 */
class SegmentConstant extends AbstractModel
{
    use SoftDeletes;
    
    protected $table = 'segment_constants';

    public function getDetailAttribute($value)
    {
        return $value ? json_decode($value) : [];
    }

    /**
     * @return BelongsTo
     */
    public function segment(): BelongsTo
    {
        return $this->BelongsTo(Segment::class, 'segment_id', 'id');
    }

    public function getValueAttribute($value)
    {
        $value = $value ? json_decode($value) : [];
        return $value;
    }
}
